# coding: utf-8

"""
    Release Manager

    This application generates version for your software.  # noqa: E501

    The version of the OpenAPI document: 0.2.0
    Contact: vitalleshchyk@gmail.com
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from client_sdk.api_client import ApiClient
from client_sdk.exceptions import (
    ApiTypeError,
    ApiValueError
)


class VersionSemanticApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def semver_generate(self, project_uuid, **kwargs):  # noqa: E501
        """Generate new semantic version number (based on gitflow)  # noqa: E501

        Semantic Versioning 2.0.0 See also http://semver.org/spec/v2.0.0.html Based on branching model [GitFlow](http://nvie.com/posts/a-successful-git-branching-model/)   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.semver_generate(project_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param str project_uuid: Project ID in UUID format (required)
        :param SemverGenerateParams body:
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: SemverTagSet
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.semver_generate_with_http_info(project_uuid, **kwargs)  # noqa: E501

    def semver_generate_with_http_info(self, project_uuid, **kwargs):  # noqa: E501
        """Generate new semantic version number (based on gitflow)  # noqa: E501

        Semantic Versioning 2.0.0 See also http://semver.org/spec/v2.0.0.html Based on branching model [GitFlow](http://nvie.com/posts/a-successful-git-branching-model/)   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.semver_generate_with_http_info(project_uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param str project_uuid: Project ID in UUID format (required)
        :param SemverGenerateParams body:
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: tuple(SemverTagSet, status_code(int), headers(HTTPHeaderDict))
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['project_uuid', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method semver_generate" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'project_uuid' is set
        if self.api_client.client_side_validation and ('project_uuid' not in local_var_params or  # noqa: E501
                                                        local_var_params['project_uuid'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `project_uuid` when calling `semver_generate`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_uuid' in local_var_params:
            path_params['projectUuid'] = local_var_params['project_uuid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in local_var_params:
            body_params = local_var_params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/release-manager.v1+json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/release-manager.v1+json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/projects/{projectUuid}/version/semantic', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SemverTagSet',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)
